Last Comment Bug 812480 - [AccessFu] Jelly Bean 4.2: TalkBack announces that a page finished loading only after one touches the display
: [AccessFu] Jelly Bean 4.2: TalkBack announces that a page finished loading on...
Status: VERIFIED FIXED
: relnote
Product: Core
Classification: Components
Component: Disability Access APIs (show other bugs)
: Trunk
: ARM Android
: -- normal (vote)
: mozilla20
Assigned To: Eitan Isaacson [:eeejay]
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-11-16 04:57 PST by Marco Zehe (:MarcoZ) on PTO until August 15
Modified: 2012-11-28 06:03 PST (History)
4 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
-
wontfix
+
verified
+
verified
-
wontfix


Attachments
Fix accessibility announcements. (1.63 KB, patch)
2012-11-16 14:05 PST, Eitan Isaacson [:eeejay]
blassey.bugs: review+
akeybl: approval‑mozilla‑aurora+
akeybl: approval‑mozilla‑beta+
Details | Diff | Splinter Review

Description Marco Zehe (:MarcoZ) on PTO until August 15 2012-11-16 04:57:08 PST
STR:
1. On a device running Jelly Bean 4.2 with TalkBack on, load any page from your home page.

Expected: When the page finishes loading, TalkBack should announce the fact that the page was loaded.
Actual: Some high-pitched beeps are heard indicating that a page scroll occurred, and "Back button disabled" is announced, but no page load.

2. Touch the display.

Result: Now, TalkBack announces the page load completion.

My impression is that the browser window loses focus to the Back button, and that the page load therefore is not being spoken until focus is returned to the window.

This is behavior introduced with Android Jelly Bean 4.2.
Comment 1 Alex Keybl [:akeybl] 2012-11-16 08:18:36 PST
dbolter - please reassign as necessary.
Comment 2 Eitan Isaacson [:eeejay] 2012-11-16 14:05:53 PST
Created attachment 682622 [details] [diff] [review]
Fix accessibility announcements.

I can't explain what changed on the Android end to make this happen. But the solution here mimics View.announceForAccessibility(), so I feel pretty good about it.
Comment 3 Marco Zehe (:MarcoZ) on PTO until August 15 2012-11-19 04:38:31 PST
I can confirm this fixes the problem and also still works on older Android versions as expected. Tested with a local build.
Comment 4 Marco Zehe (:MarcoZ) on PTO until August 15 2012-11-19 04:45:28 PST
I pushed this on Eitan's behalf so it still makes the ride, hopefully, to Aurora in time:
https://hg.mozilla.org/integration/mozilla-inbound/rev/66473f7c498f
Comment 5 Phil Ringnalda (:philor, back in August) 2012-11-19 22:23:31 PST
https://hg.mozilla.org/mozilla-central/rev/66473f7c498f
Comment 6 Marco Zehe (:MarcoZ) on PTO until August 15 2012-11-20 04:35:02 PST
Verified fixed in Nightly/20.0a1 of November 20, 2012.
Comment 7 Marco Zehe (:MarcoZ) on PTO until August 15 2012-11-20 04:43:04 PST
Comment on attachment 682622 [details] [diff] [review]
Fix accessibility announcements.

[Approval Request Comment]
Bug caused by (feature/regressing bug #): Android 4.2
User impact if declined: Blind users won't hear automatic announcements when new tabs are opened, pages finish loading, etc., once they update to Android 4.2
Testing completed (on m-c, etc.): Yes.
Risk to taking this patch (and alternatives if risky): None.
String or UUID changes made by this patch: None.
Comment 8 Alex Keybl [:akeybl] 2012-11-20 11:38:38 PST
Comment on attachment 682622 [details] [diff] [review]
Fix accessibility announcements.

[Triage comment]
Low risk a11y fix, approving for Aurora/Beta.
Comment 10 Marco Zehe (:MarcoZ) on PTO until August 15 2012-11-28 06:03:18 PST
Additional verifications on Aurora built on Nov 27, 2012, and Beta, released November 27, 2012.

Note You need to log in before you can comment on or make changes to this bug.